math.randomseed(os.time())

title		= Image.load("images/title.png")
gameBoard	= Image.load("images/background.png")
homerProfile	= Image.load("images/homer_profile.png")
homerUpset	= Image.load("images/homer_upset.png")
homerUpset1	= Image.load("images/homer_upset2.png")
homerHappy	= Image.load("images/homer_happy.png")
homerHappy2	= Image.load("images/homer_happy2.png")
characterBg	= Image.load("images/character_bg.png")
shipHit		= Image.load("images/hit.png")
shipMiss	= Image.load("images/miss.png")
selectCursor	= Image.load("images/select_cursor.png")
shipBackRight	= Image.load("images/ship_back_right.png")
shipBackUp	= Image.load("images/ship_back_up.png")
shipImage	 = Image.load("images/ship_image.png")
shipMiddleUp	= Image.load("images/ship_middle_up.png")
shipTopRight	= Image.load("images/ship_top_right.png")
shipTopUp	= Image.load("images/ship_top_up.png")
lotsDohs 	= Sound.load("sounds/Homer_32dohs.wav")
homerAnyKey	= Sound.load("sounds/Homer_anykey.wav")
homerCrap	= Sound.load("sounds/Homer_crap.wav")
homerEvil	= Sound.load("sounds/Homer_evil_homer.wav")
homerFace	= Sound.load("sounds/Homer_inuraface.wav")
homerDammit	= Sound.load("sounds/Homer_damnit.wav")
--homerOhCrap	= Sound.load("sounds/Homer_ohcrap.wav")

boardHeight	= 16
boardWidth	= 20
selectXCoord	= 3
selectYCoord	= 3
selectX		= 1
selectY		= 1
pauseMax	= 8
movePause	= pauseMax
difficulty	 = "EASY"


turnPauseMax	= 140
turnPause	= turnPauseMax
turnPauseActive = 0

selectPauseMax		= 30
selectMovePauseMax	= 10
selectPause		= selectPauseMax
selectPauseActive 	= 0


playerWinHits   = 17
opponentWinHits   = 17
changeTurn	= 0
turn		= 1
shipDirection   = "DOWN"
setShip 	= 0

-- Color constants
white = Color.new(255, 255, 255)
green = Color.new(0, 255, 0)
red   = Color.new(255, 0, 0)

playerBoardHits	= {}
playerShipPositions = {}

opponentBoardHits     = {}
opponentShipPositions = {}

battleshipSize	= 5
destroyerSize	= 4
frigateSize	= 3
subSize		= 3
minesweeperSize	= 2

battleshipSet	= 0
destroyerSet	= 0
frigateSet	= 0
subSet		= 0
minesweeperSet	= 0

function drawBG()
	screen:blit(0, 0, gameBoard)
	screen:blit(328, 1, characterBg)
	screen:blit(331, 4, homerProfile)
end

for i = 1, boardWidth do
	playerShipPositions[i] = {}
end

for i = 1, boardWidth do
	playerBoardHits[i] = {}
end

for i = 1, boardWidth do
	for j = 1, boardHeight do
		playerBoardHits[i][j] = 0
	end
end

for i = 1, boardWidth do
	opponentShipPositions[i] = {}
end

for i = 1, boardWidth do
	opponentBoardHits[i] = {}
end

for i = 1, boardWidth do
	for j = 1, boardHeight do
		opponentBoardHits[i][j] = 0
	end
end


function movePlayerShips(passedSize)

	pad = Controls.read()

	if pad:up() then
		if shipDirection == "DOWN" then
			if posy > 1  then
				posy = posy - 1
			end
		elseif shipDirection == "RIGHT" then
			if posy > 1 then
				posy = posy - 1
			end
		end



	end

	if pad:down() then
		if shipDirection == "DOWN" then
			if posy+passedSize <= boardHeight then
				posy = posy + 1
			end
		elseif shipDirection == "RIGHT" then
			if posy < boardHeight then
				posy = posy + 1
			end
		end
	end

	if pad:right() then
		if shipDirection == "RIGHT" then
			if posx+passedSize <= boardWidth then
				posx = posx + 1
			end
		elseif shipDirection == "DOWN" then
			if posx < boardWidth then
				posx = posx + 1
			end
		end
	end

	if pad:left() then
		if shipDirection == "DOWN" then
			if posx > 1 then
				posx = posx - 1
			end
		elseif shipDirection == "RIGHT" then
			if posx > 1 then
				posx = posx - 1
			end
		end
	end

	if pad:cross() then
		setShip = 1
	end

	if pad:triangle() then

		if shipDirection == "DOWN" then
			shipDirection = "RIGHT"
		elseif shipDirection == "RIGHT" then
			shipDirection = "DOWN"
		end

		if shipDirection == "RIGHT" then
			if posx+passedSize > boardWidth then
				posx = posx-passedSize
			end
		end

	end
	selectMovePause()
	pad = nil

end


function drawSetShip(passedSize)

	if shipDirection == "DOWN" then
		for i = 1,  passedSize do
	  		screen:blit(6+(16*(posx-1)), 6+(16*((posy+i)-2)), shipImage)
		end
	elseif shipDirection == "RIGHT" then
		for i = 1,  passedSize do
	  		screen:blit(6+(16*((posx+i)-2)), 6+(16*(posy-1)), shipImage)
		end
	end
	
	for i = 1, boardWidth do
		for j = 1, boardHeight do
			if playerShipPositions[i][j] == 1 then
				screen:blit(6+(16*(i-1)), 6+(16*(j-1)), shipImage)
			end  
		end
	end
	

end

function selectMovePause()

	for selectPause = 1, selectMovePauseMax do
		screen.waitVblankStart()
	end

end

function selectPause()

	for selectPause = 1, selectPauseMax do
		screen.waitVblankStart()
	end

end

function drawSetOpponentShip(passedSize)

	if shipDirection == "DOWN" then
		for i = 1,  passedSize do
--	  		screen:blit(6+(16*(posx-1)), 6+(16*((posy+i)-2)), shipImage)
		end
	elseif shipDirection == "RIGHT" then
		for i = 1,  passedSize do
--	  		screen:blit(6+(16*((posx+i)-2)), 6+(16*(posy-1)), shipImage)
		end
	end
	
	for i = 1, boardWidth do
		for j = 1, boardHeight do
			if opponentShipPositions[i][j] == 1 then
--				screen:blit(6+(16*(i-1)), 6+(16*(j-1)), shipImage)
			end  
		end
	end
	

end



function enemyShipSetup(shipSize)

	posy = 0
	posx = 1
	shipOverlap = 0

	tempNum = math.random(1,2)
	
	if tempNum == 1 then
		shipDirection = "DOWN"
	elseif tempNum == 2 then
		shipDirection = "RIGHT"
	end

	tempNum = boardWidth - shipSize
	posx =	math.random(tempNum)
	tempNum = boardHeight - shipSize
	posy =	math.random(tempNum)

	while setShip == 0 do
		drawBG()

--		movePlayerShips(shipSize)
		setShip = 1
		drawSetOpponentShip(shipSize)
	
		screen.waitVblankStart()
		screen:flip()
		if setShip == 1 then

			for i=0, shipSize-1 do
				if shipDirection == "DOWN" then
					if opponentShipPositions[posx][posy+i] == 1 then
--						shipOverlap = 1
					elseif shipDirection == "RIGHT" then
						if opponentShipPositions[posx+i][posy] == 1 then
--							shipOverlap = 1
						end
					end
				end
			end

			if shipOverlap == 1 then
				setShip = 0
			elseif shipOverlap == 0 then	
				for i=0, shipSize-1 do			
					if shipDirection == "DOWN" then
						opponentShipPositions[posx][posy+i] = 1
					elseif shipDirection == "RIGHT" then
						opponentShipPositions[posx+i][posy] = 1
					end
				end
			end
		end
		shipOverlap = 0

	end
	setShip = 0
--	selectPause()

end



function shipSetup(shipSize)

	posy = 1
	posx = 1
	shipOverlap = 0

	tempNum = math.random(1,2)
	
	if tempNum == 1 then
		shipDirection = "DOWN"
	elseif tempNum == 2 then
		shipDirection = "RIGHT"
	end

	tempNum = boardWidth - shipSize
	posx =	math.random(tempNum)
	tempNum = boardHeight - shipSize
	posy =	math.random(tempNum)

	while setShip == 0 do
		drawBG()

		movePlayerShips(shipSize)
--		setShip = 1
		drawSetShip(shipSize)

--		screen:print(10, 40, posx, white)
--		screen:print(10, 50, posy, white)
--		screen:print(10, 60, playerShipPositions[posx][posy], white)
--		screen:print(10, 70, playerShipPositions[posx+1][posy], white)
--		screen:print(10, 80, playerShipPositions[posx+2][posy], white)
--		screen:print(10, 90, playerShipPositions[posx+3][posy], white)
--		screen:print(10, 100, playerShipPositions[posx+4][posy], white)
--		screen:print(10, 110, shipSize, white)
--		screen:print(10, 120, setShip, white)
--		screen:print(10, 130, shipOverlap, white)	
--		screen:print(10, 140, shipDirection, white)
		screen.waitVblankStart()
		screen:flip()

		
		if setShip == 1 then
			for i=0, shipSize-1 do
				if shipDirection == "DOWN" then
					if playerShipPositions[posx][posy+i] == 1 then
						shipOverlap = 1
					elseif shipDirection == "RIGHT" then
						if playerShipPositions[posx+i][posy] == 1 then
							shipOverlap = 1
						end
					end
				end
			end

			if shipOverlap == 1 then
				setShip = 0
				shipOverlap = 0
			elseif shipOverlap == 0 then	
				for i=0, shipSize-1 do			
					if shipDirection == "DOWN" then
						playerShipPositions[posx][posy+i] = 1
					elseif shipDirection == "RIGHT" then
						playerShipPositions[posx+i][posy] = 1
					end
				end
			end
		end

--		shipOverlap = 0

	end
	setShip = 0
	selectPause()


end

function setPlayerShips()

	for i = 1, boardWidth do
		for j = 1, boardHeight do
			playerShipPositions[i][j] = 0
		end	
	end

	shipSetup(battleshipSize)
	shipSetup(destroyerSize)
	shipSetup(frigateSize)
	shipSetup(subSize)
	shipSetup(minesweeperSize)
	selectPause()
	for i = 1, 100 do
		screen:clear()
		if turn == 1 then
			screen:print(150, 80, "E N E M Y   S E T U P", white)
		end	
		screen.waitVblankStart()
	 	screen:flip()
	end

end

function setEnemyShips()

	for i = 1, boardWidth do
		for j = 1, boardHeight do
			opponentShipPositions[i][j] = 0
		end	
	end

	enemyShipSetup(battleshipSize)
	enemyShipSetup(destroyerSize)
	enemyShipSetup(frigateSize)
	enemyShipSetup(subSize)
	enemyShipSetup(minesweeperSize)

	selectPause()
	for i = 1, 100 do
		screen:clear()
		if turn == 1 then
			screen:print(150, 80, "P L A Y E R   T U R N", white)
		end	
		screen.waitVblankStart()
	 	screen:flip()
	end

end



showTitle 	= 1

function titleShow()

	homerAnyKey:play()
	while showTitle == 1 do
		screen:blit(0, 0, title)

		pad = Controls.read()

		if pad:start() then
			showTitle = 0
		end		

		if pad:cross() then
			showTitle = 0
		end		

		if pad:down() then
			difficulty = "HARD"
		end		

		if pad:up() then
			difficulty = "EASY"
		end		

		if difficulty == "EASY" then
			screen:print(190, 170, ">", white)
		elseif difficulty == "HARD" then
			screen:print(190, 180, ">", white)
		end
		screen:print(170, 150, "CHOOSE DIFFICULTY:", red)
		screen:print(200, 170, "E A S Y", white)
		screen:print(200, 180, "H A R D", white)
		screen:print(390,260, "by k_man316", white)	
			

		screen.waitVblankStart()
		screen:flip()
	end
end


function turnChanger()
	
	if changeTurn == 1 then
		if turn == 1 then
			turn = 2
		elseif turn == 2 then
			turn = 1
		end

		for i = 1, 200 do
		end

		for i = 1, 100 do
			screen:clear()
			if turn == 1 then
				screen:print(150, 80, "P L A Y E R   T U R N", white)
			elseif turn == 2 then
				screen:print(170, 80, "C P U   T U R N", white)
			end	
			screen.waitVblankStart()
			screen:flip()
		end
		changeTurn = 0
	end
end

function playHitSound()
	homerEvil:play()
	screen:blit(331, 4, homerHappy)

end

function playMissSound()

	playSound = math.random(1, 10)
	screen:blit(331, 4, homerUpset1)

	if playSound == 1 then
		homerCrap:play()
	elseif playSound == 2 then
		homerDammit:play()
		screen:blit(331, 4, homerUpset)
	elseif playSound == 4 then
		homerCrap:play()
	elseif playSound == 6 then
		homerDammit:play()
		screen:blit(331, 4, homerUpset)
	elseif playSound == 8 then
		screen:blit(331, 4, homerUpset)
		homerCrap:play()
	elseif playSound == 10 then
		homerDammit:play()
	end

	

end

function readInput()

	pad = Controls.read()
	if pad:up() then
		if selectY > 1 then
			selectYCoord = selectYCoord - 16
			selectY = selectY - 1	
			movePause = pauseMax - 1
		end
	end
	
	if pad:down() then
		if selectY < boardHeight then
			selectYCoord = selectYCoord + 16
			selectY = selectY + 1	
			movePause = pauseMax - 1
		end
	end

	if pad:right() then
		if selectX < boardWidth then
			selectX = selectX + 1
			selectXCoord = selectXCoord + 16
			movePause = pauseMax - 1
		end
	end

	if pad:left() then
		if selectX > 1 then
			selectX = selectX - 1
			selectXCoord = selectXCoord - 16
			movePause = pauseMax - 1
		end
	end


	if pad:cross() then
		if turn == 1 then
			if difficulty == "EASY" then
				if opponentBoardHits[selectX][selectY] == 1 then
				elseif opponentBoardHits[selectX+1][selectY] == 1 then
				elseif opponentBoardHits[selectX][selectY+1] == 1 then
				elseif opponentBoardHits[selectX+1][selectY+1] == 1 then
					-- do nothing: hit spot taken
				end
				if opponentBoardHits[selectX][selectY] == 0 then
					if opponentShipPositions[selectX][selectY] == 1 then
						opponentBoardHits[selectX][selectY] = 1
						movePause = pauseMax
						opponentWinHits = opponentWinHits - 1
						changeTurn = 1
						turnPauseActive = 1
					elseif opponentShipPositions[selectX][selectY] == 0 then
						opponentBoardHits[selectX][selectY] = 2
						movePause = pauseMax 
						turnPauseActive = 1
						changeTurn = 1
					end
				end
				if opponentBoardHits[selectX+1][selectY] == 0 then
					if opponentShipPositions[selectX+1][selectY] == 1 then
						opponentBoardHits[selectX+1][selectY] = 1
						movePause = pauseMax
						opponentWinHits = opponentWinHits - 1
						changeTurn = 1
						turnPauseActive = 1
					elseif opponentShipPositions[selectX+1][selectY] == 0 then
						opponentBoardHits[selectX+1][selectY] = 2
						movePause = pauseMax 
						turnPauseActive = 1
						changeTurn = 1
					end
				end
				if opponentBoardHits[selectX][selectY+1] == 0 then
					if opponentShipPositions[selectX][selectY+1] == 1 then
						opponentBoardHits[selectX][selectY+1] = 1
						movePause = pauseMax
						opponentWinHits = opponentWinHits - 1
						changeTurn = 1
						turnPauseActive = 1
					elseif opponentShipPositions[selectX][selectY+1] == 0 then
						opponentBoardHits[selectX][selectY+1] = 2
						movePause = pauseMax 
						turnPauseActive = 1
						changeTurn = 1
					end
				end
				if opponentBoardHits[selectX+1][selectY+1] == 0 then
					if opponentShipPositions[selectX+1][selectY+1] == 1 then
						opponentBoardHits[selectX+1][selectY+1] = 1
						movePause = pauseMax
						opponentWinHits = opponentWinHits - 1
						changeTurn = 1
						turnPauseActive = 1
					elseif opponentShipPositions[selectX+1][selectY+1] == 0 then
						opponentBoardHits[selectX+1][selectY+1] = 2
						movePause = pauseMax 
						turnPauseActive = 1
						changeTurn = 1
					end
				end
			
				if playerBoardHits[selectX][selectY] == 2 then
					-- do nothing: missed spot taken
				elseif playerBoardHits[selectX][selectY] == 2 then
					-- do nothing: missed spot taken
				elseif playerBoardHits[selectX][selectY] == 2 then
					-- do nothing: missed spot taken
				elseif playerBoardHits[selectX][selectY] == 2 then
					-- do nothing: missed spot taken
				end

			end


			if difficulty == "HARD" then
				if opponentBoardHits[selectX][selectY] == 1 then
					-- do nothing: hit spot taken
				elseif opponentBoardHits[selectX][selectY] == 0 then
					if opponentShipPositions[selectX][selectY] == 1 then
						opponentBoardHits[selectX][selectY] = 1
						movePause = pauseMax
						opponentWinHits = opponentWinHits - 1
						changeTurn = 1
						turnPauseActive = 1
					elseif opponentShipPositions[selectX][selectY] == 0 then
						opponentBoardHits[selectX][selectY] = 2
						movePause = pauseMax 
						turnPauseActive = 1
						changeTurn = 1
					end
				elseif playerBoardHits[selectX][selectY] == 2 then
					-- do nothing: missed spot taken
				end
			end

		end


		if turn == 2 then
			if playerBoardHits[selectX][selectY] == 1 then
				-- do nothing: hit spot taken
			elseif playerBoardHits[selectX][selectY] == 0 then
				if playerShipPositions[selectX][selectY] == 1 then
					playerBoardHits[selectX][selectY] = 1
					movePause = pauseMax
					playerWinHits = playerWinHits - 1
					changeTurn = 1
					turnPauseActive = 1
					playMissSound()
				elseif playerShipPositions[selectX][selectY] == 0 then
					playerBoardHits[selectX][selectY] = 2
					changeTurn = 1
					turnPauseActive = 1
					playHitSound()

				end
			elseif playerBoardHits[selectX][selectY] == 2 then
				-- do nothing: missed spot taken
			end
		end


	end

	pad = nil
end



titleShow()
setPlayerShips()
setEnemyShips()

function isGameOver()

	if playerWinHits <= 0 then
		lotsDohs:play()
		while playerWinHits <= 0 do

			screen:clear()
			screen:print(150, 80, "Y O U  W I N ! ! !", green)


			screen.waitVblankStart()
			screen:flip()

			pad = Controls.read()

			if pad:triangle() then
				playerWinHits = 17
			end
		end
	end

	if opponentWinHits <= 0 then
		lotsDohs:play()
		while playerWinHits <= 0 do

			screen:clear()
			screen:print(150, 80, "Y O U  L O S E ! ! !", red)


			screen.waitVblankStart()
			screen:flip()

			pad = Controls.read()

			if pad:triangle() then
				opponentWinHits = 17
				playerWinHIts   = 17
			end
		end
	end

end


function drawBoard()
	if turn == 2 then
		for i = 1, boardWidth do
			for j = 1, boardHeight do
				if playerShipPositions[i][j] == 1 then
					screen:blit(6+(16*(i-1)), 6+(16*(j-1)), shipImage)
				end  

				if playerBoardHits[i][j] == 1 then
					screen:blit(5+(16*(i-1)), 6+(16*(j-1)), shipHit)
				elseif playerBoardHits[i][j] == 2 then
					screen:blit(5+(16*(i-1)), 6+(16*(j-1)), shipMiss)
				end
--			screen:print(i*7, j*7, playerBoardHits[i][j], white)
--			screen:print(i*7, j*7, playerShipPositions[i][j], white)
			end
		end
	elseif turn == 1 then
		for i = 1, boardWidth do
			for j = 1, boardHeight do
--				if opponentShipPositions[i][j] == 1 then
--					screen:blit(6+(16*(i-1)), 6+(16*(j-1)), shipImage)
--				end  
				if opponentBoardHits[i][j] == 1 then
					screen:blit(5+(16*(i-1)), 6+(16*(j-1)), shipHit)
				elseif opponentBoardHits[i][j] == 2 then
					screen:blit(5+(16*(i-1)), 6+(16*(j-1)), shipMiss)
				end
--			screen:print(i*7, j*7, opponentBoardHits[i][j], white)
--			screen:print(i*7, j*7, opponentShipPositions[i][j], white)
			end
		end
	end
end

function cpuFire()

	cpuDone = 0
	playerSelectX = selectX
	playerSelectY = selectY
	cpuHit = 0

	while cpuDone == 0 do


		if difficulty == "EASY" then
		selectX = math.random(1,boardWidth-1)
		selectY = math.random(1,boardHeight-1)

		if playerBoardHits[selectX][selectY] == 1 then
		elseif playerBoardHits[selectX+1][selectY] == 1 then
		elseif playerBoardHits[selectX][selectY+1] == 1 then
		elseif playerBoardHits[selectX+1][selectY+1] == 1 then
		end
		-- do nothing: hit spot taken

		if playerBoardHits[selectX][selectY] == 0 then
			if playerShipPositions[selectX][selectY] == 1 then
				playerBoardHits[selectX][selectY] = 1
				movePause = pauseMax
				playerWinHits = playerWinHits - 1
				changeTurn = 1
				turnPauseActive = 1
				cpuDone = 1
				cpuHit = 1
			elseif playerShipPositions[selectX][selectY] == 0 then
				playerBoardHits[selectX][selectY] = 2
				changeTurn = 1
				turnPauseActive = 1
				cpuDone = 1

			end
		end
		if playerBoardHits[selectX+1][selectY] == 0 then
			if playerShipPositions[selectX+1][selectY] == 1 then
				playerBoardHits[selectX+1][selectY] = 1
				movePause = pauseMax
				playerWinHits = playerWinHits - 1
				changeTurn = 1
				turnPauseActive = 1
				cpuDone = 1
				cpuHit = 1
			elseif playerShipPositions[selectX+1][selectY] == 0 then
				playerBoardHits[selectX+1][selectY] = 2
				changeTurn = 1
				turnPauseActive = 1
				cpuDone = 1
			end
		end
		if playerBoardHits[selectX][selectY+1] == 0 then
			if playerShipPositions[selectX][selectY+1] == 1 then
				playerBoardHits[selectX][selectY+1] = 1
				movePause = pauseMax
				playerWinHits = playerWinHits - 1
				changeTurn = 1
				turnPauseActive = 1
				cpuDone = 1
				cpuHit = 1
			elseif playerShipPositions[selectX][selectY+1] == 0 then
				playerBoardHits[selectX][selectY+1] = 2
				changeTurn = 1
				turnPauseActive = 1
				cpuDone = 1
			end
		end
		if playerBoardHits[selectX+1][selectY+1] == 0 then
			if playerShipPositions[selectX+1][selectY+1] == 1 then
				playerBoardHits[selectX+1][selectY+1] = 1
				movePause = pauseMax
				playerWinHits = playerWinHits - 1
				changeTurn = 1
				turnPauseActive = 1
				cpuHit = 1
				cpuDone = 1
			elseif playerShipPositions[selectX+1][selectY+1] == 0 then
				playerBoardHits[selectX+1][selectY+1] = 2
				changeTurn = 1
				turnPauseActive = 1
				cpuDone = 1
			end
		end

		if playerBoardHits[selectX][selectY] == 2 then
			-- do nothing: missed spot taken
		elseif playerBoardHits[selectX+1][selectY] == 2 then
		elseif playerBoardHits[selectX][selectY+1] == 2 then
		elseif playerBoardHits[selectX+1][selectY+1] == 2 then
		end

		end		

		if difficulty == "HARD" then

			selectX = math.random(1,boardWidth)
			selectY = math.random(1,boardHeight)


			if playerBoardHits[selectX][selectY+1] == 0 then
				if playerShipPositions[selectX][selectY+1] == 1 then
					playerBoardHits[selectX][selectY+1] = 1
					movePause = pauseMax
					playerWinHits = playerWinHits - 1
					changeTurn = 1
					turnPauseActive = 1
					cpuDone = 1
					cpuHit = 1
				elseif playerShipPositions[selectX][selectY+1] == 0 then
					playerBoardHits[selectX][selectY+1] = 2
					changeTurn = 1
					turnPauseActive = 1
					cpuDone = 1
				end
			end


			if playerBoardHits[selectX][selectY] == 1 then
				-- do nothing: hit spot taken
			end
			if playerBoardHits[selectX][selectY] == 2 then
				-- do nothing: missed spot taken
			end
		end
	end
	
	if cpuHit == 1 then
		playHitSound()
	elseif cpuHit == 0 then
		playMissSound()
	end

	selectX = playerSelectX
	selectY = playerSelectY

end

function drawBG()
	screen:blit(0, 0, gameBoard)
	screen:blit(328, 1, characterBg)
	screen:blit(331, 4, homerProfile)
end

function drawCursor()

	if difficulty == "EASY" then
		if turn == 1 then
			screen:blit(selectXCoord, selectYCoord, selectCursor)
			screen:blit(selectXCoord, selectYCoord+16, selectCursor)
			screen:blit(selectXCoord+16, selectYCoord, selectCursor)
			screen:blit(selectXCoord+16, selectYCoord+16, selectCursor)
		end
	end
	if difficulty == "HARD" then
		if turn == 1 then
			screen:blit(selectXCoord, selectYCoord, selectCursor)
		end
	end

end


--***********************************************************
-- main
--
--
--***********************************************************
while true do

	drawBG()

	isGameOver()
	
	drawCursor()

--	screen:print(300, 50, turn, white)
--	screen:print(300, 50, movePause, white)
	pad = Controls.read()
	
	if pad:triangle() then
		break
	end


	if turn == 1 then
		if movePause == pauseMax then
			readInput()
			pad = Controls.read()
		elseif movePause < pauseMax and movePause > 1 then
			movePause = movePause - 1
		elseif movePause <= 1 then
			movePause = pauseMax
		end
	elseif turn == 2 then
		cpuFire()
	end

	drawBoard()
	screen.waitVblankStart()
	screen:flip()

	if turnPauseActive == 1 then
		for turnPause = 1, turnPauseMax do
			screen.waitVblankStart()
--			screen:flip()
			turnPauseActive = 0
		end
		turnPause = 1
	end
		

	turnChanger()

end
